# Ipopt::MatrixSpace Class Reference

MatrixSpace base class, corresponding to the Matrix base class. More...

`#include <IpMatrix.hpp>`

Inheritance diagram for Ipopt::MatrixSpace:
[legend]

List of all members.

## Public Member Functions
virtual Matrix * | MakeNew () const =0
| Pure virtual method for creating a new Matrix of the corresponding type.
Index | NRows () const
| Accessor function for the number of rows.
Index | NCols () const
| Accessor function for the number of columns.
bool | IsMatrixFromSpace (const Matrix &matrix) const
| Method to test if a given matrix belongs to a particular matrix space.
Constructors/Destructors
| MatrixSpace (Index nRows, Index nCols)
| Constructor, given the number rows and columns of all matrices generated by this MatrixSpace.
virtual | ~MatrixSpace ()
| Destructor.
## Private Member Functions
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| MatrixSpace ()
| default constructor
| MatrixSpace (const MatrixSpace &)
| Copy constructor.
MatrixSpace & | operator= (const MatrixSpace &)
| Overloaded Equals Operator.
## Private Attributes
const Index | nRows_
| Number of rows for all matrices of this type.
const Index | nCols_
| Number of columns for all matrices of this type.

## Detailed Description

MatrixSpace base class, corresponding to the Matrix base class.

For each Matrix implementation, a corresponding MatrixSpace has to be implemented. A MatrixSpace is able to create new Matrices of a specific type. The MatrixSpace should also store information that is common to all Matrices of that type. For example, the dimensions of a Matrix is stored in the MatrixSpace base class.

Definition at line 239 of file IpMatrix.hpp.

## Constructor & Destructor Documentation

Ipopt::MatrixSpace::MatrixSpace | ( | Index | nRows,
|  | Index | nCols |
| ) |  |  | `[inline]`

Constructor, given the number rows and columns of all matrices generated by this MatrixSpace.

Definition at line 247 of file IpMatrix.hpp.

virtual Ipopt::MatrixSpace::~MatrixSpace | ( |  | ) | `[inline, virtual]`

Destructor.

Definition at line 254 of file IpMatrix.hpp.

Ipopt::MatrixSpace::MatrixSpace | ( |  | ) | `[private]`

default constructor

Ipopt::MatrixSpace::MatrixSpace | ( | const MatrixSpace & |  | ) | `[private]`

Copy constructor.

## Member Function Documentation

virtual Matrix* Ipopt::MatrixSpace::MakeNew | ( |  | ) | const`[pure virtual]`

Pure virtual method for creating a new Matrix of the corresponding type.

Implemented in Ipopt::CompoundMatrixSpace, Ipopt::DenseGenMatrixSpace, Ipopt::ExpandedMultiVectorMatrixSpace, Ipopt::ExpansionMatrixSpace, Ipopt::MultiVectorMatrixSpace, Ipopt::ScaledMatrixSpace, Ipopt::SumMatrixSpace, Ipopt::SymMatrixSpace, Ipopt::SymScaledMatrixSpace, Ipopt::TransposeMatrixSpace, Ipopt::ZeroMatrixSpace, and Ipopt::GenTMatrixSpace.

Index Ipopt::MatrixSpace::NRows | ( |  | ) | const`[inline]`

Accessor function for the number of rows.

Definition at line 264 of file IpMatrix.hpp.

Index Ipopt::MatrixSpace::NCols | ( |  | ) | const`[inline]`

Accessor function for the number of columns.

Definition at line 269 of file IpMatrix.hpp.

bool Ipopt::MatrixSpace::IsMatrixFromSpace | ( | const Matrix & | matrix | ) | const`[inline]`

Method to test if a given matrix belongs to a particular matrix space.

Definition at line 277 of file IpMatrix.hpp.

MatrixSpace& Ipopt::MatrixSpace::operator= | ( | const MatrixSpace & |  | ) | `[private]`

Overloaded Equals Operator.

Reimplemented in Ipopt::CompoundMatrixSpace, Ipopt::CompoundSymMatrixSpace, Ipopt::DiagMatrixSpace, Ipopt::IdentityMatrixSpace, Ipopt::LowRankUpdateSymMatrixSpace, Ipopt::ScaledMatrixSpace, Ipopt::SumMatrixSpace, Ipopt::SymMatrixSpace, Ipopt::SymScaledMatrixSpace, Ipopt::TransposeMatrixSpace, and Ipopt::ZeroMatrixSpace.

## Member Data Documentation

const Index Ipopt::MatrixSpace::nRows_`[private]`

Number of rows for all matrices of this type.

Definition at line 302 of file IpMatrix.hpp.

const Index Ipopt::MatrixSpace::nCols_`[private]`

Number of columns for all matrices of this type.

Definition at line 304 of file IpMatrix.hpp.

The documentation for this class was generated from the following file:

- src/LinAlg/IpMatrix.hpp

All Classes Files Functions Variables Typedefs Enumerations Enumerator Friends Defines